# Redirector 1.1 Copyright (c) 1999 Alexander Staubo <alex@mop.no>
#     Extended 9/1999 Dylan Jay <djay@slarken.org.au>           
# See README.txt for more information about this Zope product.

# $Header: /personal/alex/zope/Redirector/src/Redirector.py 4     23.08.99 14:04 Alex $

__version__ = '$Revision: 4 $'[11:-2]

from Globals import Persistent, HTMLFile, HTML, MessageDialog
from AccessControl.Role import RoleManager
import Acquisition
import sys
import string
import OFS
import Globals
import time
import copy
import re

manage_addRedirectorForm = HTMLFile('addRedirector_form', globals())

def manage_addRedirector(self, id, title = '', Target = '',
  Mappings = {}, HardMap = 0, REQUEST = None):
  '''Add a Redirector into the system'''

  Obj = Redirector()
  Obj.id = id
  Obj.title = title
  Obj._init(Target, Mappings, HardMap)
  self._setObject(id, Obj)
  if REQUEST:
    return self.manage_main(self, REQUEST)

class RedirectorBase(Acquisition.Implicit, OFS.Folder.Folder,
  RoleManager):
  '''Redirector base class'''

  meta_type = 'Redirector'
  icon = 'misc_/Redirector/icon'
  manage = manage_main = HTMLFile('manageRedirector', globals())

  manage_options = (
    {'icon': '', 'label': 'Edit', 'action': 'manage_main',
    'target': 'manage_main'},
    {'icon': '', 'label': 'Security', 'action': 'manage_access',
    'target': 'manage_main'},
  )

  __ac_permissions__ = OFS.Folder.Folder.__ac_permissions__ + (
    ('View management screens', ('manage',)),
    ('Change configuration', ('manage_makeChanges',)),
    ('Use Redirector services',('',)),
  )

  def __init__(self):
    '''Initialize'''

    self.Target = ''
    self.Mappings = {}
    self.HardMap = 0

  def _init(self, Target, Mappings = {}, HardMap = 0):
    '''Initialize with configuration'''

    self.Mappings = copy.copy(Mappings)
    self.Target = Target
    self.HardMap = HardMap

  def manage_makeChanges(self, title = '', Target = '',
    HardMap = 0, MapFrom = [], MapTo = [], REQUEST = None):
    '''Perform changes'''

    self.title = title

    NewMap = {}
    i = 0
    while i < len(MapFrom):
      NewMap[MapFrom[i]] = MapTo[i]
      i = i + 1
    for k in NewMap.keys():
      if not (k and NewMap[k]):
        del NewMap[k]

    self._init(Target, NewMap, HardMap)

    if REQUEST:
      return MessageDialog(
        title = 'Changed %s' % self.id,
        message = '%s has been updated' % self.id,
        action = REQUEST['URL1'] + '/manage_main',
        target = 'manage_main')

  def __bobo_traverse__(self, REQUEST, Name = ''):
  
    if Name[:6] != 'manage':
      import ExtensionClass
      class doTraverse(ExtensionClass.Base):
         def __init__(self, path, Mappings, Target, HardMap):
            self.path = path
            self.Mappings = Mappings
            self.Target = Target
            self.HardMap = HardMap
         
         def __bobo_traverse__(self, REQUEST, Name = ''):
            self.path = self.path + '/' + Name
            return self.__class__(self.path, self.Mappings, self.Target, self.HardMap)
            
         def __call__(self, REQUEST):
            path = self.path
            if REQUEST['QUERY_STRING']:
              path = path + "?" + REQUEST['QUERY_STRING']
            for k in self.Mappings.keys():
              if re.match(k, path):
                 path = re.sub(k, self.Mappings[k], path)
                 break
            else:
              if self.HardMap:
                 raise 'Redirect', self.Target
            def Merge(Target, Url):
              if Url[:5] == 'http:' or Url[:4] == 'ftp:':
                 return Url
              else:
                 return Target + Url
            raise 'Redirect', Merge(self.Target , path)
            
      return doTraverse(Name, self.Mappings, self.Target, self.HardMap)
     

    if hasattr(self, 'aq_base'):
      b = self.aq_base
      if hasattr(b, Name):
        return getattr(self, Name)
    try:
      return self[Name]
    except:
      return getattr(self, Name)

  def index_html(self):
    raise 'Redirect', self.Target

class Redirector(RedirectorBase, Persistent):
  '''Redirector product'''
